/*
* Loads translation into an html document
*/

(function ($) {
  $.fn.loadTranslation = function (obj, options) {
    $('#reportOptionsHelp').attr('title',transValues['reportHelpMsg']);
   
    function setElementValue(element, value, name) {
          var type = element.type || element.tagName;
          if (type == null)
              return;
          type = type.toLowerCase();
          switch (type) {

            case 'h1','h2':
              if (options === "transOptions") {
                element.innerText = value;
              }
              break;
            
              case 'p': 
              case 'span':
                if (options === "transOptions") {
                  element.innerText = value;
                }
                break;
            
                case 'option': 
                  if (options === "transOptions") {
                    element.innerText = value;
                  }
                  break;

            case 'radio':
                if (value.toString().toLowerCase() == element.value.toLowerCase())
                    $(element).attr("checked", "checked");
                break;

            case 'checkbox':
                if (value)
                    $(element).attr("checked", "checked");
                break;

            case 'select-multiple':
              if (options === "transOptions") {
                    //Translate label and placeholder
                  $("label[for='"+name+"-selectized']")[0].innerText = value;
                  $("#"+name+"-selectized").attr("placeholder",gTrs("recuringTrans","selectPlaceholder"));
              } else {
                  //Selectized items work in a different way:
                  if ($(element).hasClass('selectized')) {
                    element.selectize.clearOptions();
                      var values = value.constructor == Array ? value : [value];
                        for (var j = 0; j < values.length; j++) {
                            $.each(values[j], function( index, val ) {
                                element.selectize.addOption({value: index, text: val});
                            });
                        }
                  } else {
                    var values = value.constructor == Array ? value : [value];
                    for (var i = 0; i < element.options.length; i++) {
                        for (var j = 0; j < values.length; j++) {
                            element.options[i].selected |= element.options[i].value == values[j];
                        }
                    }
                  }
              }
              break;

            case 'select':
            case 'select-one':
                if (options === "transOptions") {
                  //Translate label and placeholder
                  $("label[for='"+name+"-selectized']")[0].innerText = value;
                  $("#"+name+"-selectized").attr("placeholder", recuringTrans['selectPlaceholder']);

                  break;
                } else {
                  //Selectized items work in a different way:
                  if ($(element).hasClass('selectized')) {
                    element.selectize.clearOptions();
                    var values = value.constructor == Array ? value : [value];
                    for (var i = 0; i < element.options.length; i++) {
                        $.each(values[i],  function( index, val ) {
                          element.selectize.addOption({value: index, text: val});
                        });
                      }
                      break;
                  }
                } 
            case 'text':
              if (options === "transOptions") {
                //Translate label and placeholder
                $("label[for='"+name+"']")[0].innerText = value;
                $("#"+name).attr("placeholder",$("#"+name).attr("placeholder").charAt(0)+" "+value);
                break;
              }
            case 'hidden':
                $(element).attr("value", value);
                break;
            case 'a':
                $(element).attr("data-mfb-label", value);
                $(element).attr("aria-label", value);
                break;
             case 'img': //Assumption is that value is in the HREF$ALT format
                var iPosition = value.indexOf('$');
                var src = "";
                var alt = "";
                if (iPosition > 0) {
                    src = value.substring(0, iPosition);
                    alt = value.substring(iPosition + 1);
                }
                else {
                    src = value;
                    var iPositionStart = value.lastIndexOf('/')+1;
                    var iPositionEnd = value.indexOf('.');
                    alt = value.substring(iPositionStart, iPositionEnd);
                }
                $(element).attr("src", src);
                $(element).attr("alt", alt);
                break;
            case 'textarea':
                //Set textarea field value
                $(element).val(value);
                break;
            case 'button':
            case 'submit':
                if (element.tagName === "INPUT") $(element).val(value);
                else if (element.tagName === "BUTTON") element.innerText = value;
                break;
            case 'date':
              if (options === "transOptions") {
                $("label[for='"+name+"']")[0].innerText = value;
              } else {
                //Set date field value
                $(element).val(value);
              }
              break;
            case 'label':
              $("#"+name +"> p")[0].innerText = value;
              commentSelect = name.replace('Label','');
              placeHolder = $("#"+commentSelect+"-selectized").attr("placeholder") || "";
              if (placeHolder && placeHolder.length > 0) placeHolder = placeHolder.charAt(0);
              $("#"+commentSelect+"-selectized").attr("placeholder",recuringTrans['selectPlaceholder']);
              break;
            case 'submit':
              $("#"+name).attr("value",value);
              break;
            default:
                try {
                    $(element).html(value);
                } catch (exc) { }
            }
      }

      function browseTranslationJSON(obj, element, name) {
        
          // no object
          if (obj == undefined) {
            
          }
          // branch
          else if (obj.constructor == Object) {

              for (var prop in obj) {
                  if (prop == null)
                      continue;
                  //Find an element with class, id, name, or rel attribute that matches the propertu name
                  var child = jQuery.makeArray(jQuery("." + prop, element)).length > 0 ? jQuery("." + prop, element) :
                                                  jQuery("#" + prop, element).length > 0 ? jQuery("#" + prop, element) :
                                                  jQuery('[name="' + prop + '"]', element).length > 0 ? jQuery('[name="' + prop + '"]', element) : jQuery('[rel="' + prop + '"]');
                                                  
                  if (child.length === 0) {
                    child = jQuery.makeArray(jQuery("." + prop)).length > 0 ? jQuery("." + prop) :
                            jQuery("#" + prop).length > 0 ? jQuery("#" + prop) :
                            jQuery('[name="' + prop + '"]').length > 0 ? jQuery('[name="' + prop + '"]') : jQuery('[rel="' + prop + '"]');
                  }

                  if (child.length != 0)
                      browseTranslationJSON(obj[prop], jQuery(child, element), prop);
              }
          }
          // array
          else if (obj.constructor == Array) {
            
              if (element.length > 0 && element[0].tagName == "SELECT") {
                  setElementValue(element[0], obj, name);
              } else {
                  var arr = jQuery.makeArray(element);
                  //how many duplicate
                  var nbToCreate = obj.length - arr.length;
                  var i = 0;
                  for (iExist = 0; iExist < arr.length; iExist++) {
                      if (i < obj.length) {
                          $(element).eq(iExist).loadTranslationJSON(obj[i]);
                      }
                      i++;
                  }
                  //fill started by last
                  i = obj.length - 1;
                  for (iCreate = 0; iCreate < nbToCreate; iCreate++) {
                      //duplicate the last
                      $(arr[arr.length - 1]).clone(true).insertAfter(arr[arr.length - 1]).loadTranslationJSON(obj[i]);
                      i--;
                  }
              }
          }
          // data only
          else {
            
              var value = obj;
              var type;
              if (element.length > 0) {
                  for (i = 0; i < element.length; i++)
                      setElementValue(element[i], obj, name);
              }
              else {
                  setElementValue(element, obj, name);
              }
          }
      } //function browseJSON end

      var defaults = {
      };

      properties = $.extend(defaults, options);

      return this.each(function () {
          if (obj.constructor == String) {
              var element = $(this);
              $.get(obj, function (data) {
                  element.loadJSON(data);
              });
          }

          else {
              browseTranslationJSON(obj, this);
          }
      });
  };
})(jQuery);

//Get translation -> Can be extended in the future
function gTrs(group, field) {
    return eval(group)[field] ? eval(group)[field] : "";
}